//
//
//
#include "defines.h"

//
//
//
void initMatrix_int(int ***m2D, int d1, int d2)
{
  int i;
      
  if(!(*m2D = (int **) calloc(d1, sizeof(int *))))
    FATAL_ERROR_0("initMatrix_int: memory allocation problem\n", -1);
  if(!((*m2D)[0] = (int *) calloc(d1 * d2, sizeof(int))))
    FATAL_ERROR_0("initMatrix_int: memory allocation problem\n", -1);

  for(i = 1; i < d1; i++)
    (*m2D)[i] = (*m2D)[i-1] + d2;
}

//
//
//
void initMatrix_double(double ***m2D, int d1, int d2)
{
  int i;
      
  if(!(*m2D = (double **) calloc(d1, sizeof(double *))))
    FATAL_ERROR_0("initMatrix_double: memory allocation problem\n", -1);
  if(!((*m2D)[0] = (double *) calloc(d1 * d2, sizeof(double))))
    FATAL_ERROR_0("initMatrix_double: memory allocation problem\n", -1);

  for(i = 1; i < d1; i++)
    (*m2D)[i] = (*m2D)[i-1] + d2;
}

//
//
//
void initMatrix_ushort(unsigned short ***m2D, int d1, int d2)
{
  int i;
      
  if(!(*m2D = (unsigned short **) calloc(d1, sizeof(unsigned short *))))
    FATAL_ERROR_0("initMatrix_ushort: memory allocation problem\n", -1);
  if(!((*m2D)[0] = (unsigned short *) calloc(d1 * d2, sizeof(unsigned short))))
    FATAL_ERROR_0("initMatrix_ushort: memory allocation problem\n", -1);

  for(i = 1; i < d1; i++)
    (*m2D)[i] = (*m2D)[i-1] + d2;
}

//
//
//
void initMatrix3D_int(int ****m3D, int d1, int d2, int d3)
{
  int  j;
      
  if(!((*m3D) = (int ***) calloc(d1, sizeof(int **))))
    FATAL_ERROR_0("initMatrix3D_int: memory allocation problem\n", -1);

  for(j = 0; j < d1; j++)
    initMatrix_int((*m3D) + j, d2, d3);
}

//
//
//
void initMatrix3D_double(double ****m3D, int d1, int d2, int d3)
{
  int  j;
      
  if(!((*m3D) = (double ***) calloc(d1, sizeof(double **))))
    FATAL_ERROR_0("initMatrix3D_double: memory allocation problem\n", -1);

  for(j = 0; j < d1; j++)
    initMatrix_double((*m3D) + j, d2, d3);
}

//
//
//
void initMatrix3D_ushort(unsigned short ****m3D, int d1, int d2, int d3)
{
  int  j;
      
  if(!((*m3D) = (unsigned short ***) calloc(d1, sizeof(unsigned short **))))
    FATAL_ERROR_0("initMatrix3D_ushort: memory allocation problem\n", -1);

  for(j = 0; j < d1; j++)
    initMatrix_ushort((*m3D) + j, d2, d3);
}

//
//
//
void initMatrix4D_int(int *****m4D, int d1, int d2, int d3, int d4)
{
  int  j;

  if(!((*m4D) = (int ****) calloc(d1, sizeof(int ***))))
    FATAL_ERROR_0("initMatrix4D_int: memory allocation problem\n", -1);

  for(j = 0; j < d1; j++)
    initMatrix3D_int((*m4D) + j, d2, d3, d4);
}

//
//
//
void initMatrix4D_double(double *****m4D, int d1, int d2, int d3, int d4)
{
  int  j;

  if(!((*m4D) = (double ****) calloc(d1, sizeof(double ***))))
    FATAL_ERROR_0("initMatrix4D_double: memory allocation problem\n", -1);

  for(j = 0; j < d1; j++)
    initMatrix3D_double((*m4D) + j, d2, d3, d4);
}

//
//
//
void initMatrix4D_ushort(unsigned short *****m4D, int d1, int d2, int d3, int d4)
{
  int  j;

  if(!((*m4D) = (unsigned short ****) calloc(d1, sizeof(unsigned short ***))))
    FATAL_ERROR_0("initMatrix4D_ushort: memory allocation problem\n", -1);

  for(j = 0; j < d1; j++)
    initMatrix3D_ushort((*m4D) + j, d2, d3, d4);
}


//
//
//
void destroyMatrix_int(int **m2D)
{
  if(m2D)
  {
    if(m2D[0])
      free(m2D[0]);
    else
      FATAL_ERROR_0("destroyMatrix_int: memory free problem\n", -1);
    free(m2D);
  } 
  else
  {
    FATAL_ERROR_0("destroyMatrix_int: memory free problem\n", -1);
  }
}

//
//
//
void destroyMatrix_double(double **m2D)
{
  if(m2D)
  {
    if(m2D[0])
      free(m2D[0]);
    else
      FATAL_ERROR_0("destroyMatrix_double: memory free problem\n", -1);
    free(m2D);
  } 
  else
  {
    FATAL_ERROR_0("destroyMatrix_double: memory free problem\n", -1);
  }
}

//
//
//
void destroyMatrix_ushort(unsigned short **m2D)
{
  if(m2D)
  {
    if(m2D[0])
      free(m2D[0]);
    else
      FATAL_ERROR_0("destroyMatrix_ushort: memory free problem\n", -1);
    free(m2D);
  } 
  else
  {
    FATAL_ERROR_0("destroyMatrix_ushort: memory free problem\n", -1);
  }
}

//
//
//
void destroyMatrix3D_int(int ***m3D, int d1)
{
  int i;

  if(m3D)
  {
    for(i = 0; i < d1; i++)
      destroyMatrix_int(m3D[i]);
    free(m3D);
  } 
  else
  {
    FATAL_ERROR_0("destroyMatrix3D_int: memory free problem\n", -1);
  }
}

//
//
//
void destroyMatrix3D_double(double ***m3D, int d1)
{
  int i;

  if(m3D)
  {
    for(i = 0; i < d1; i++)
      destroyMatrix_double(m3D[i]);
    free(m3D);
  } 
  else
  {
    FATAL_ERROR_0("destroyMatrix3D_double: memory free problem\n", -1);
  }
}

//
//
//
void destroyMatrix3D_ushort(unsigned short ***m3D, int d1)
{
  int i;

  if(m3D)
  {
    for(i = 0; i < d1; i++)
      destroyMatrix_ushort(m3D[i]);
    free(m3D);
  } 
  else
  {
    FATAL_ERROR_0("destroyMatrix3D_ushort: memory free problem\n", -1);
  }
}

//
//
//
void destroyMatrix4D_int(int ****m4D, int d1, int d2)
{
  int  j;

  if(m4D)
  {
    for(j = 0; j < d1; j++)
      destroyMatrix3D_int(m4D[j], d2);
    free(m4D);
  } 
  else
  {
    FATAL_ERROR_0("destroyMatrix4D_int: memory free problem\n", -1);
  }
}

//
//
//
void destroyMatrix4D_double(double ****m4D, int d1, int d2)
{
  int  j;

  if(m4D)
  {
    for(j = 0; j < d1; j++)
      destroyMatrix3D_double(m4D[j], d2);
    free(m4D);
  } 
  else
  {
    FATAL_ERROR_0("destroyMatrix4D_double: memory free problem\n", -1);
  }
}

//
//
//
void destroyMatrix4D_ushort(unsigned short ****m4D, int d1, int d2)
{
  int  j;

  if(m4D)
  {
    for(j = 0; j < d1; j++)
      destroyMatrix3D_ushort(m4D[j], d2);
    free(m4D);
  } 
  else
  {
    FATAL_ERROR_0("destroyMatrix4D_ushort: memory free problem\n", -1);
  }
}



